//-----------------------------------------------------------------------------------------------------------------------------
// X264Encoder / deklaracia triedy
//-----------------------------------------------------------------------------------------------------------------------------

#ifndef X264ENCODER_H
#define X264ENCODER_H
//-----------------------------------------------------------------------------------------------------------------------------

#include <stdint.h>
#include <stdio.h>
extern "C" {
#include <x264.h>
}
#include <string>
//-----------------------------------------------------------------------------------------------------------------------------

class X264Encoder
{
public:
    X264Encoder();
    ~X264Encoder();
    bool open(std::string filename, int width, int height, int fps = 25);
    bool encode(char* data);
    bool close();

private:
    void setParams();

public:
    int width;
    int height;
    int fps;

    x264_picture_t pic_in;
    x264_picture_t pic_out;
    x264_param_t params;
    x264_nal_t *nals;
    x264_t *encoder;
    int num_nals;

    int pts;
    FILE *fp;
};
//-----------------------------------------------------------------------------------------------------------------------------

#endif // X264ENCODER_H
